//---------------------------------------------------------------------------

#include "resultset.h"

//---------------------------------------------------------------------------

/*
	vOCŃlCeBuꂽNX񋟂AggŎgpł悤
	łB

	lCeBuNX tTJSNativeInstance pNXɍ쐬ÃlC
	eBuNXƂ̃C^[tF[X tTJSNativeClassForPlugin x[Xɍ쐬
	܂B

	uTJS2 t@Xv́ugݍ݂̎v́u{IȎgvɂƓ
	NXł͍쐬܂BAvOCŎsATJS2 t@
	XɂƂ͎኱̎dقȂ邱ƂɒӂĂB
*/


//---------------------------------------------------------------------------
// eXgNX
//---------------------------------------------------------------------------
/*
	eIuWFNg (iTJSDispatch2 C^[tF[X) ɂ̓lCeBuCX^X
	Ă΂AiTJSNativeInstance ^̃IuWFNgo^邱ƂłA
	IuWFNgoƂł܂B
	܂AlCeBuCX^X̎łBlCeBuCX^Xɂ
	tTJSNativeInstance NX𓱏o܂BtTJSNativeInstance 
	iTJSNativeInstance ̊{IȓĂ܂B
*/
class NI_Database : public tTJSNativeInstance // lCeBuCX^X
{
public:
	sqlite3 *db;

	NI_Database()
	{
		// RXgN^
		/*
			NI_Database ̃RXgN^łBC++ NXƂĂ̏ q
			Construct ōς܂ĂAConstruct ł͍̏ŏ̕
			ɂ邱Ƃ߂܂B̗ł́Af[^o Value ɏ
			lƂ 0 ݒ肵Ă܂B
		 */
		db = NULL;
	}

	tjs_error TJS_INTF_METHOD
		Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj)
	{
		// TJS2 IuWFNg쐬ƂɌĂ΂
		/*
			TJS2  new Zq TJS2 IuWFNg쐬ƂɌĂ΂܂B
			numparams  param  new Zqɓnꂽ\Ă܂B
			tjs_obj ́A쐬 TJS IuWFNgłB
			̗ł́A (ɂꂪ void Ŗ)A Value
			̏lƂĐݒ肵Ă܂B
		*/

		// ΂lƂ Value ɓ
		ttstr base;
		ttstr name;
		if (numparams >= 1 && param[0]->Type() == tvtString) {
			// 1: DBzupX
			// Storages.getLocalName() gOS̃t@C擾
			iTJSDispatch2 * global = TVPGetScriptDispatch();
			tTJSVariant storages;
			if (TJS_SUCCEEDED(global->PropGet(0, TJS_W("Storages"), NULL, &storages, global))) {
				tTJSVariant result;
				if (TJS_SUCCEEDED(storages.AsObjectClosureNoAddRef().FuncCall(0, TJS_W("getLocalName"), NULL, &result, 1, &param[0], NULL))) {
					base = result;
				}
			}
			global->Release();
		}
		if (numparams >= 2 && param[1]->Type() == tvtString) {
			// 2: DB
			name = *param[1];
		}
		
		ttstr dbpath;
		if (base.GetLen() == 0 && name.GetLen() == 0) {
			// f[^x[X
			dbpath = TJS_W(":memory:");
		} else {
			// pXꍇ̓Jg
			if (base.GetLen() == 0) {
				base = TJS_W(".\\");
			}
			// DBꍇ͕W
			if (name.GetLen() == 0) {
				name = TJS_W("database.db");
			}
			// x[XpXɃpXw肪ȂΒǉ
			if (base.GetLastChar() != '\\') {
				base += TJS_W("\\");
			}
			dbpath = base;
			dbpath +=  name;
		}

		//TVPAddLog(dbpath);

		if (sqlite3_open16(dbpath.c_str(), &db) != SQLITE_OK) {
			ttstr msg = dbpath;
			msg += ":can't open db\n";
			TVPAddImportantLog(msg);
			return S_FALSE;
		}
		
		return S_OK;
	}

	void TJS_INTF_METHOD Invalidate()
	{
		// IuWFNgƂɌĂ΂
		if (db) {
			sqlite3_close(db);
		}
	}

	// SQLG[R[h̎擾
	int getErrorCode() {
		return sqlite3_errcode(db);
	}

	// SQLG[bZ[W̎擾
	ttstr getErrorMessage() {
		return ttstr((const wchar_t*)sqlite3_errmsg16(db));
	}
	
	// -----------------------------------------------------
    // gUNV
	void begin() {
		sqlite3_exec(db, "BEGIN TRANSACTION;", NULL, NULL, NULL);
	}
	void commit() {
		sqlite3_exec(db, "COMMIT;", NULL, NULL, NULL);
	}
	void rollback() {
		sqlite3_exec(db, "ROLLBACK;", NULL, NULL, NULL);
	}
};
//---------------------------------------------------------------------------
/*
	 NI_Database ̃IuWFNg쐬ĕԂ̊֐łB
	q TJSCreateNativeClassForPlugin ̈Ƃēn܂B
*/
static iTJSNativeInstance * TJS_INTF_METHOD Create_NI_Database()
{
	return new NI_Database();
}
//---------------------------------------------------------------------------
/*
	TJS2 ̃lCeBuNX͈ӂ ID ŋʂĂKv܂B
	͌q TJS_BEGIN_NATIVE_MEMBERS }NŎIɎ擾܂A
	 ID i[ϐƁA̕ϐŐ錾܂B
	lɂ͖ ID \ -1 w肵ĂB
*/
#define TJS_NATIVE_CLASSID_NAME ClassID_Database
static tjs_int32 TJS_NATIVE_CLASSID_NAME = -1;
//---------------------------------------------------------------------------
/*
	TJS2 ṕuNXv쐬ĕԂ֐łB
*/
static iTJSDispatch2 * Create_NC_Database()
{
	/*
		܂ANX̃x[XƂȂNXIuWFNg쐬܂B
		ɂ TJSCreateNativeClassForPlugin p܂B
		TJSCreateNativeClassForPlugin ̑P̓NXAQ
		lCeBuCX^XԂ֐w肵܂B
		쐬IuWFNgꎞIɊi[郍[Jϐ̖O
		classobj łKv܂B
	*/
	tTJSNativeClassForPlugin * classobj =
		TJSCreateNativeClassForPlugin(TJS_W("Database"), Create_NI_Database);


	/*
		TJS_BEGIN_NATIVE_MEMBERS }NłBɂ TJS2 ŎgpNX
		w肵܂B
		̃}N TJS_END_NATIVE_MEMBERS }Nŋ܂ꂽꏊɁANX
		oƂȂׂ\bhvpeB̋Lq܂B
	*/
	TJS_BEGIN_NATIVE_MEMBERS(/*TJS class name*/Database)

		/*
			 finalize \bh錾܂Bfinalize ɑ鏈
			tTJSNativeInstance::Invalidate I[o[Ch邱Ƃłł
			܂̂ŁAʏ͋̃\bhŏ\łB
		*/
		TJS_DECL_EMPTY_FINALIZE_METHOD

		/*
			(TJS) RXgN^錾܂BTJS ŃNXƂA
			NXŃNXƓ̃\bh錾Ă镔ɑ܂B

			TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL }N̂PԖڂ̈̓lCeBu
			CX^XɊ蓖ĂϐŁAQʖڂ̈͂̕ϐ̌^łB
			̗ł̂̃ubNł NI_Database * _this Ƃϐp\ŁA
			lCeBuCX^XɃANZX邱Ƃł܂B
			}N̂RԖڂ̈́ATJS ŎgpNXw肵܂B
			TJS_END_NATIVE_CONSTRUCTOR_DECL }N̈lłB
			ARXgN^ɑ鏈 tTJSNativeInstance::Construct
			I[o[Ch鎖Ŏł̂ŁAł͉ S_OK 
			܂B
		*/
		TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(
			/*var.name*/_this,
			/*var.type*/NI_Database,
			/*TJS class name*/Database)
		{
			// NI_Database::Construct ɂeLqł̂
			// ł͉Ȃ
			return TJS_S_OK;
		}
		TJS_END_NATIVE_CONSTRUCTOR_DECL(/*TJS class name*/Database)

		/*
			exec \bh錾܂B\bh
			TJS_BEGIN_NATIVE_METHOD_DECL  TJS_END_NATIVE_METHOD_DECL ̗}N
			ɓ̂w肷Kv܂B̃}NŎgp\ȕϐ
			tjs_int numparams  tTJSVariant **param āAꂼAn
			̐ƈĂ܂B̃\bhł͎͂gpĂ
			B20`21sڂ́AIuWFNglCeBuCX^Xo
			߂̃}NłB̗ł _this Ƃ NI_Database * ^̕ϐɃlC
			eBuCX^XoAƂӖɂȂ܂Bȍ~A_this Ƃ
			ϐŃlCeBuCX^XɃANZXł܂B23sڂŁA
			lCeBuCX^X Print \bhĂяoĂ܂B
		*/
		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/exec) // exec \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_Database);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			ResultSet rs(_this->db);

			// ֐t@NV邩H
			bool closure = false;
			if (numparams >= 2 && param[1]->Type() == tvtObject) {
				closure = true;
			}
			
			if (rs.open(param[0]->GetString())) {

				// oCh
				for (int i=2; i<numparams; i++) {
					rs.bind(*param[i]);
				}
				
				// N[WĂяo
				while (rs.next()) {
					if (closure) {
						tTJSVariant result;
						int count = rs.getCount();
						tTJSVariant **args = new tTJSVariant*[count];
						for (i=0;i<count;i++) {
							args[i] = rs.get(i);
						}
						result.Clear();
						param[1]->AsObjectClosureNoAddRef().FuncCall(0, NULL, NULL, &result, count, args, NULL);
						for (i=0;i<count;i++) {
							delete args[i];
						}
						delete args;
						if (result.AsInteger()) {
							break;
						}
					}
				}
			}
			if (result) {
				*result = (tjs_int32)rs.getErrorCode();
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/exec)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/begin)
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_Database);
			_this->begin();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/begin)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/commit)
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_Database);
			_this->commit();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/commit)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/rollback)
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_Database);
			_this->rollback();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/rollback)

		/*
			ł͓ǂݏopvpeB錾Ă܂BZb^[̑
			TJS_DENY_NATIVE_PROP_SETTER ƂɂAǂݏopvpeB
			邱Ƃł܂B
		*/
		TJS_BEGIN_NATIVE_PROP_DECL(errorMessage) // errorMessage ǂݏopvpeB
		{
			TJS_BEGIN_NATIVE_PROP_GETTER
			{
				TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_Database);
				if (result) {
					*result = _this->getErrorMessage();
				}
				return TJS_S_OK;
			}
			TJS_END_NATIVE_PROP_GETTER

			TJS_DENY_NATIVE_PROP_SETTER
		}
		TJS_END_NATIVE_PROP_DECL(errorMessage)

		TJS_BEGIN_NATIVE_PROP_DECL(errorCode) // errorCode ǂݏopvpeB
		{
			TJS_BEGIN_NATIVE_PROP_GETTER
			{
				TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_Database);
				if (result) {
					*result = (tjs_int32)_this->getErrorCode();
				}
				return TJS_S_OK;
			}
			TJS_END_NATIVE_PROP_GETTER

			TJS_DENY_NATIVE_PROP_SETTER
		}
		TJS_END_NATIVE_PROP_DECL(errorCode)
			
	TJS_END_NATIVE_MEMBERS

	/*
		̊֐ classobj Ԃ܂B
	*/
	return classobj;
}
//---------------------------------------------------------------------------
/*
	TJS_NATIVE_CLASSID_NAME ͈ꉞ undef Ăق悢ł傤
*/
#undef TJS_NATIVE_CLASSID_NAME
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// eXgNX
//---------------------------------------------------------------------------
/*
	eIuWFNg (iTJSDispatch2 C^[tF[X) ɂ̓lCeBuCX^X
	Ă΂AiTJSNativeInstance ^̃IuWFNgo^邱ƂłA
	IuWFNgoƂł܂B
	܂AlCeBuCX^X̎łBlCeBuCX^Xɂ
	tTJSNativeInstance NX𓱏o܂BtTJSNativeInstance 
	iTJSNativeInstance ̊{IȓĂ܂B
*/
class NI_ResultSet : public tTJSNativeInstance // lCeBuCX^X
{
	iTJSDispatch2 *dbInstance;
	
public:
	ResultSet *rs;
	NI_ResultSet()
	{
		// RXgN^
		/*
			NI_ResultSet ̃RXgN^łBC++ NXƂĂ̏ q
			Construct ōς܂ĂAConstruct ł͍̏ŏ̕
			ɂ邱Ƃ߂܂B̗ł́Af[^o Value ɏ
			lƂ 0 ݒ肵Ă܂B
		*/
		dbInstance = NULL;
		rs = NULL;
	}

	tjs_error TJS_INTF_METHOD
		Construct(tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *tjs_obj)
	{
		// TJS2 IuWFNg쐬ƂɌĂ΂
		/*
			TJS2  new Zq TJS2 IuWFNg쐬ƂɌĂ΂܂B
			numparams  param  new Zqɓnꂽ\Ă܂B
			tjs_obj ́A쐬 TJS IuWFNgłB
			̗ł́A (ɂꂪ void Ŗ)A Value
			̏lƂĐݒ肵Ă܂B
		*/

		// ΂lƂ Value ɓ
		if (numparams >= 1 && param[0]->Type() == tvtObject) {
			dbInstance = param[0]->AsObject();
			NI_Database *db;
			if (TJS_SUCCEEDED(dbInstance->NativeInstanceSupport(TJS_NIS_GETINSTANCE, ClassID_Database, (iTJSNativeInstance**)&db))) {
				rs = new ResultSet(db->db);
				if (numparams >= 2 && param[1]->Type() == tvtString) {
					rs->open(param[1]->GetString());
				}
				return S_OK;
			}
		}
		
		TVPAddImportantLog("arg1 must be Database");
		return TJS_E_INVALIDOBJECT;
	}

	void TJS_INTF_METHOD Invalidate()
	{
		// IuWFNgƂɌĂ΂
		/*
			IuWFNgƂɌĂ΂郁\bhłBɏI
			Ɨǂł傤B̗ł͉܂B
		*/
		if (dbInstance) {
			dbInstance->Release();
			delete rs;
		}
	}

};
//---------------------------------------------------------------------------
/*
	 NI_ResultSet ̃IuWFNg쐬ĕԂ̊֐łB
	q TJSCreateNativeClassForPlugin ̈Ƃēn܂B
*/
static iTJSNativeInstance * TJS_INTF_METHOD Create_NI_ResultSet()
{
	return new NI_ResultSet();
}
//---------------------------------------------------------------------------
/*
	TJS2 ̃lCeBuNX͈ӂ ID ŋʂĂKv܂B
	͌q TJS_BEGIN_NATIVE_MEMBERS }NŎIɎ擾܂A
	 ID i[ϐƁA̕ϐŐ錾܂B
	lɂ͖ ID \ -1 w肵ĂB
*/
#define TJS_NATIVE_CLASSID_NAME ClassID_ResultSet
static tjs_int32 TJS_NATIVE_CLASSID_NAME = -1;
//---------------------------------------------------------------------------
/*
	TJS2 ṕuNXv쐬ĕԂ֐łB
*/
static iTJSDispatch2 * Create_NC_ResultSet()
{
	/*
		܂ANX̃x[XƂȂNXIuWFNg쐬܂B
		ɂ TJSCreateNativeClassForPlugin p܂B
		TJSCreateNativeClassForPlugin ̑P̓NXAQ
		lCeBuCX^XԂ֐w肵܂B
		쐬IuWFNgꎞIɊi[郍[Jϐ̖O
		classobj łKv܂B
	*/
	tTJSNativeClassForPlugin * classobj =
		TJSCreateNativeClassForPlugin(TJS_W("ResultSet"), Create_NI_ResultSet);


	/*
		TJS_BEGIN_NATIVE_MEMBERS }NłBɂ TJS2 ŎgpNX
		w肵܂B
		̃}N TJS_END_NATIVE_MEMBERS }Nŋ܂ꂽꏊɁANX
		oƂȂׂ\bhvpeB̋Lq܂B
	*/
	TJS_BEGIN_NATIVE_MEMBERS(/*TJS class name*/ResultSet)

		/*
			 finalize \bh錾܂Bfinalize ɑ鏈
			tTJSNativeInstance::Invalidate I[o[Ch邱Ƃłł
			܂̂ŁAʏ͋̃\bhŏ\łB
		*/
		TJS_DECL_EMPTY_FINALIZE_METHOD

		/*
			(TJS) RXgN^錾܂BTJS ŃNXƂA
			NXŃNXƓ̃\bh錾Ă镔ɑ܂B

			TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL }N̂PԖڂ̈̓lCeBu
			CX^XɊ蓖ĂϐŁAQʖڂ̈͂̕ϐ̌^łB
			̗ł̂̃ubNł NI_ResultSet * _this Ƃϐp\ŁA
			lCeBuCX^XɃANZX邱Ƃł܂B
			}N̂RԖڂ̈́ATJS ŎgpNXw肵܂B
			TJS_END_NATIVE_CONSTRUCTOR_DECL }N̈lłB
			ARXgN^ɑ鏈 tTJSNativeInstance::Construct
			I[o[Ch鎖Ŏł̂ŁAł͉ S_OK 
			܂B
		*/
		TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(
			/*var.name*/_this,
			/*var.type*/NI_ResultSet,
			/*TJS class name*/ResultSet)
		{
			// NI_ResultSet::Construct ɂeLqł̂
			// ł͉Ȃ
			return TJS_S_OK;
		}
		TJS_END_NATIVE_CONSTRUCTOR_DECL(/*TJS class name*/ResultSet)

		/*
			print \bh錾܂B\bh
			TJS_BEGIN_NATIVE_METHOD_DECL  TJS_END_NATIVE_METHOD_DECL ̗}N
			ɓ̂w肷Kv܂B̃}NŎgp\ȕϐ
			tjs_int numparams  tTJSVariant **param āAꂼAn
			̐ƈĂ܂B̃\bhł͎͂gpĂ
			B20`21sڂ́AIuWFNglCeBuCX^Xo
			߂̃}NłB̗ł _this Ƃ NI_ResultSet * ^̕ϐɃlC
			eBuCX^XoAƂӖɂȂ܂Bȍ~A_this Ƃ
			ϐŃlCeBuCX^XɃANZXł܂B23sڂŁA
			lCeBuCX^X Print \bhĂяoĂ܂B
		*/
		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/open) // open \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			bool ret = _this->rs->open(param[0]->GetString());
			if (result) {
				*result = ret;
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/open)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/next) // next \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_ResultSet);
			bool ret = _this->rs->next();
			if (result) {
				*result = ret;
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/next)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/reset) // reset \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_ResultSet);
			_this->rs->reset();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/reset)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/close) // close \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this, /*var. type*/NI_ResultSet);
			_this->rs->close();
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/close)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/bind) // bind \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			_this->rs->bind(*param[0], numparams >= 2 ? (int)*param[1] : 0);
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/bind)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/getType) // getType \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			if (result) {
				*result= (tjs_int32)_this->rs->getType((int)*param[0]);
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/getType)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/isNull) // getType \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
			if (numparams < 1) return TJS_E_BADPARAMCOUNT;
			if (result) {
				*result= _this->rs->isNull((int)*param[0]);
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/isNull)

		TJS_BEGIN_NATIVE_METHOD_DECL(/*func. name*/get) // get \bh
		{
			TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
			if (numparams >= 1) {
				if (param[0]->Type() == tvtString) {
					_this->rs->get(result, param[0]->GetString(), numparams >= 2 ? param[1] : NULL);
				} else if (param[0]->Type() == tvtInteger) {
					_this->rs->get(result, (int)*param[0], numparams >= 2 ? param[1] : NULL);
				} else {
					_this->rs->get(result, 0, numparams >= 2 ? param[1] : NULL);
				}
			} else {
				_this->rs->get(result);
			}
			return TJS_S_OK;
		}
		TJS_END_NATIVE_METHOD_DECL(/*func. name*/get)

		TJS_BEGIN_NATIVE_PROP_DECL(length) // length ǂݏopvpeB
		{
			TJS_BEGIN_NATIVE_PROP_GETTER
			{
				TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
				if (result) {
					*result = (tjs_int32)_this->rs->getCount();
				}
				return TJS_S_OK;
			}
			TJS_END_NATIVE_PROP_GETTER

			TJS_DENY_NATIVE_PROP_SETTER
		}
		TJS_END_NATIVE_PROP_DECL(length)

		TJS_BEGIN_NATIVE_PROP_DECL(errorMessage) // errorMessage ǂݏopvpeB
		{
			TJS_BEGIN_NATIVE_PROP_GETTER
			{
				TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
				if (result) {
					*result = _this->rs->getErrorMessage();
				}
				return TJS_S_OK;
			}
			TJS_END_NATIVE_PROP_GETTER

			TJS_DENY_NATIVE_PROP_SETTER
		}
		TJS_END_NATIVE_PROP_DECL(errorMessage)

		TJS_BEGIN_NATIVE_PROP_DECL(errorCode) // errorCode ǂݏopvpeB
		{
			TJS_BEGIN_NATIVE_PROP_GETTER
			{
				TJS_GET_NATIVE_INSTANCE(/*var. name*/_this,	/*var. type*/NI_ResultSet);
				if (result) {
					*result = (tjs_int32)_this->rs->getErrorCode();
				}
				return TJS_S_OK;
			}
			TJS_END_NATIVE_PROP_GETTER

			TJS_DENY_NATIVE_PROP_SETTER
		}
		TJS_END_NATIVE_PROP_DECL(errorCode)

	TJS_END_NATIVE_MEMBERS

	/*
		̊֐ classobj Ԃ܂B
	*/
	return classobj;
}
//---------------------------------------------------------------------------
/*
	TJS_NATIVE_CLASSID_NAME ͈ꉞ undef Ăق悢ł傤
*/
#undef TJS_NATIVE_CLASSID_NAME
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason,
	void* lpReserved)
{
	return 1;
}
//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;
extern "C" HRESULT _stdcall _export V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	tTJSVariant val;

	// TJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	{
		//-----------------------------------------------------------------------
		// 1 ܂NXIuWFNg쐬
		iTJSDispatch2 * tjsclass = Create_NC_Database();
		
		// 2 tjsclass  tTJSVariant ^ɕϊ
		val = tTJSVariant(tjsclass);
		
		// 3 ł val  tjsclass ێĂ̂ŁAtjsclass 
		//   Release 
		tjsclass->Release();
		
		
		// 4 global  PropSet \bhpAIuWFNgo^
		global->PropSet(
			TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
			TJS_W("Database"), // o ( Ȃ炸 TJS_W( ) ň͂ )
			NULL, // qg ( {̓õnbVlANULL ł悢 )
			&val, // o^l
			global // ReLXg ( global ł悢 )
			);
		//-----------------------------------------------------------------------
	}

	{
		//-----------------------------------------------------------------------
		// 1 ܂NXIuWFNg쐬
		iTJSDispatch2 * tjsclass = Create_NC_ResultSet();
		
		// 2 tjsclass  tTJSVariant ^ɕϊ
		val = tTJSVariant(tjsclass);
		
		// 3 ł val  tjsclass ێĂ̂ŁAtjsclass 
		//   Release 
		tjsclass->Release();
		
		
		// 4 global  PropSet \bhpAIuWFNgo^
		global->PropSet(
			TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
			TJS_W("ResultSet"), // o ( Ȃ炸 TJS_W( ) ň͂ )
			NULL, // qg ( {̓õnbVlANULL ł悢 )
			&val, // o^l
			global // ReLXg ( global ł悢 )
			);
		//-----------------------------------------------------------------------
	}
	
	// - global  Release 
	global->Release();

	// Ao^֐ꍇ 1 ` 4 JԂ


	// val NAB
	// ͕KsBȂ val ێĂIuWFNg
	//  Release ꂸAɎg TVPPluginGlobalRefCount mɂȂȂB
	val.Clear();


	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	return S_OK;
}
//---------------------------------------------------------------------------
extern "C" HRESULT _stdcall _export V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐B

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	if(TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;
		// E_FAIL AƁAPlugins.unlink \bh͋UԂ

	/*
		ANX̏ꍇAɁuIuWFNggpłvƂƂ
		m邷ׂ܂B{Iɂ́APlugins.unlink ɂvOC̉
		댯łƍlĂ ( Plugins.link ŃNAŌ
		ŃvOCAvOIƓɎIɉ̂g)B
	*/

	// TJS ̃O[oIuWFNgɓo^ Database NXȂǂ폜

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();

	// - global  DeleteMember \bhpAIuWFNg폜
	if(global)
	{
		// TJS ̂ɉĂƂȂǂ
		// global  NULL ɂȂ蓾̂ global  NULL łȂ
		// Ƃ`FbN

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("Database"), // o
			NULL, // qg
			global // ReLXg
			);

		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			TJS_W("ResultSet"), // o
			NULL, // qg
			global // ReLXg
			);
	}
	
	// - global  Release 
	if(global) global->Release();

	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	return S_OK;
}
//---------------------------------------------------------------------------

